﻿Type.registerNamespace('Carpa.Dress');
Sys.UI.Controls.DressDisplayMode = function () {
  throw Error.notImplemented();
}
Sys.UI.Controls.DressDisplayMode.prototype = {
  master: 0, // 总量格式
  standard: 1, // 标准格式
  detail: 2 // 明细格式
}
Sys.UI.Controls.DressDisplayMode.registerEnum("Sys.UI.Controls.DressDisplayMode");

Sys.UI.Controls.StandardItemChangeEventArgs = function (rowData, changingField) {
  Sys.UI.Controls.StandardItemChangeEventArgs.initializeBase(this);
  this._rowData = rowData;
  this._changingField = changingField;
}

Sys.UI.Controls.StandardItemChangeEventArgs.prototype = {
  get_rowData: function () {
    return this._rowData;
  },
  get_changingField: function () {
    return this._changingField;
  }
}
Sys.UI.Controls.StandardItemChangeEventArgs.registerClass('Sys.UI.Controls.StandardItemChangeEventArgs', Sys.EventArgs);

Sys.UI.Controls.StandardMergeEventArgs = function () {
  Sys.UI.Controls.StandardMergeEventArgs.initializeBase(this);
  this._mergeFields = []
}
Sys.UI.Controls.StandardMergeEventArgs.prototype = {
  get_mergeFields: function () {
    return this._mergeFields;
  },

  add_mergeField: function (mergeField) {
    if (!mergeField) {
      return;
    }
    Array.add(this._mergeFields, mergeField)
  }
}
Sys.UI.Controls.StandardMergeEventArgs.registerClass('Sys.UI.Controls.StandardMergeEventArgs', Sys.EventArgs);

Sys.UI.Controls.StandardMergingEventArgs = function (mergedRowData, items) {
  Sys.UI.Controls.StandardMergingEventArgs.initializeBase(this);
  this._mergedRowData = mergedRowData;
  this._items = items;
}
Sys.UI.Controls.StandardMergingEventArgs.prototype = {
  get_mergedRowData: function () {
    return this._mergedRowData;
  },
  get_items: function () {
    return this._items;
  }
}
Sys.UI.Controls.StandardMergingEventArgs.registerClass('Sys.UI.Controls.StandardMergingEventArgs', Sys.EventArgs);

//标准模式尺寸排序
Sys.UI.Controls.StandardSizeSortEventArgs = function (sizes) {
  Sys.UI.Controls.StandardSizeSortEventArgs.initializeBase(this);
  this._sizes = sizes;
}
Sys.UI.Controls.StandardSizeSortEventArgs.prototype = {
  get_sizes: function () {
    return this._sizes;
  },

  set_sizes: function (value) {
    this._sizes = value;
  }
}
Sys.UI.Controls.StandardSizeSortEventArgs.registerClass('Sys.UI.Controls.StandardSizeSortEventArgs', Sys.EventArgs);

//总量模式合并字段
Sys.UI.Controls.MasterMergeEventArgs = function () {
  Sys.UI.Controls.MasterMergeEventArgs.initializeBase(this);
  this._mergeFields = []
}
Sys.UI.Controls.MasterMergeEventArgs.prototype = {
  get_mergeFields: function () {
    return this._mergeFields;
  },

  add_mergeField: function (mergeField) {
    if (!mergeField) {
      return;
    }
    Array.add(this._mergeFields, mergeField)
  }
}
Sys.UI.Controls.MasterMergeEventArgs.registerClass('Sys.UI.Controls.MasterMergeEventArgs', Sys.EventArgs);


//总量模式修改合并字段
Sys.UI.Controls.MasterModifyMergeEventArgs = function () {
  Sys.UI.Controls.MasterModifyMergeEventArgs.initializeBase(this);
  this._isModify = false;
}
Sys.UI.Controls.MasterModifyMergeEventArgs.prototype = {
  get_isModify: function () {
    return this._isModify;
  },

  set_isModify: function (isModify) {
    this._isModify = isModify;
  }
}
Sys.UI.Controls.MasterModifyMergeEventArgs.registerClass('Sys.UI.Controls.MasterModifyMergeEventArgs', Sys.EventArgs);


//总量模式合并事件
Sys.UI.Controls.MasterMergingEventArgs = function (mergedRowData, items) {
  Sys.UI.Controls.MasterMergingEventArgs.initializeBase(this);
  this._mergedRowData = mergedRowData;
  this._items = items;
}
Sys.UI.Controls.MasterMergingEventArgs.prototype = {
  get_mergedRowData: function () {
    return this._mergedRowData;
  },
  get_items: function () {
    return this._items;
  }
}
Sys.UI.Controls.MasterMergingEventArgs.registerClass('Sys.UI.Controls.MasterMergingEventArgs', Sys.EventArgs);


Carpa.Dress.DressBase = function (element) {
  Carpa.Dress.DressBase.initializeBase(this, [element]);

  this._qtyExpandName = "qtyExpand";
  this._displayMode = Sys.UI.Controls.DressDisplayMode.master;
  this._lastDisplayMode = null;
  this._bodyChangedDisplayMode = null;
  this._displayModeChanged = false;
  this._gridSetting = null;
  this._maxSizeCount = 0;

  this._lastList = null;
  this._dataSourceList = null;
  this._isModify = false;
  this._modifyEventArgs = null; //用于记录修改的参数
  this._modifyColumn = null; //用于记录修改的列
  this._isModifyRowIndex = -1;
  this._newPtypeFlag = null;
  this._isChangeBodyHeight = false;
  //this._sizeRowCache = "sizeRowCache";

  this._dataCache = null;
  this._dressMode = true; //服装模式
  this._sizeInfoListCache = {};
  this._changeExistPtype = false; //标记是否正在标准模式下修改已经添加的商品信息的类型
  this._detailsData = null;
  this._dressGrid = true; //用于判断列对象
}
Carpa.Dress.DressBase.prototype = {
  initialize: function () {
    Carpa.Dress.DressBase.callBaseMethod(this, 'initialize');
  },

  dispose: function () {
    Carpa.Dress.DressBase.callBaseMethod(this, 'dispose');
    this._detailsData = null;
    this._modifyColumn = null;
    this._modifyEventArgs = null;
  },

  _hasPager: function () {
    return this.findPager() != null;
  },

	/*
	 * 重写Grid的方法
	 */
  _createColumns: function () {
    Carpa.Dress.DressBase.callBaseMethod(this, '_createColumns');
    if (!this._dressMode) {
      return;
    }
    this._doExpandColumn(); //如果已经初始化则根据数据源动态展开和折叠列
    this._bindColumnsEvent();
  },

	/*
	 * 重写Grid的方法
	 */
  doSelectionChanged: function () {
    if (this._dressMode) {
      this._changeColumnCaption();
    }

    Carpa.Dress.DressBase.callBaseMethod(this, 'doSelectionChanged');
  },

  get_dressMode: function () {
    return this._dressMode;
  },

  set_dressMode: function (value) {
    this._dressMode = value;
  },
	/*
	 * 重写Grid的方法
	 */
  set_dataSource: function (value) {
    var pagerId = this.get_pagerId();
    Carpa.Dress.DressBase.callBaseMethod(this, 'set_dataSource', [value]);
    if (!this._dressMode) {
      return;
    }
    //绑定新值
    this._lastList = this._dataCache = this._dataSource;
		/*if (pagerId) { //分页情况下，数据在服务器端转换并返回了
		return;
		}*/
    var _this = this;
    window.asyncCall(function () {
      //_this._isModify = true;
      _this._dataSourceList = _this._changeDataToList(value); //调用Grid方法，获取数据列表
      var supportsObjProp = (_this._dataSourceList == value); //设置是否支持对象属性
      _this._doExpandData(supportsObjProp); //列展开、数据变换
      // this.set_displayMode(Sys.UI.Controls.DressDisplayMode.standard);
      _this._refresh_displayMode(); //由于数据绑定在列扩展之后，因此可能导致数据展示与对应的模式不匹配的问题，需要重新刷新
      _this._detailsData = _this.getDressData();
    });
  },

  getDressData: function () {
    if (!this.get_isInitialized() || !this._dressMode) {
      return [];
    }
    if (!this._isModify) {
      return this._dataCache ? this._dataCache : [];
    }

    this._isModify = false; //重置修改标记

    switch (this._displayMode) {
      case Sys.UI.Controls.DressDisplayMode.master:
        this._dataCache = this._doDetailData();
      case Sys.UI.Controls.DressDisplayMode.standard:
        this._dataCache = this._doDetailData();
        break;
      case Sys.UI.Controls.DressDisplayMode.detail:
        this._dataCache = this._detailsData; //this._gridSaveData();
        this._clearQtyExpand(this._dataCache);
        break;
    }

    if (this._isModifyRowIndex) {
      this._isModifyRowIndex = -1;
    }
    //重置数据
    this.get_form().get_dataController().setValue(this.get_dataField(), this._dataCache);
    return this._dataCache;
  },

  _clearQtyExpand: function (data) {
    if (!data || !this._dressMode) {
      return;
    }
    for (var i = 0, count = data.length; i < count; i++) {
      for (var j in data[i]) {
        if (!j.startsWith(this._qtyExpandName)) {
          continue;
        }
        delete data[i][j];
      }
    }
  },

  _clearQtyExpandItem: function (rowData) {
    for (var name in rowData) {
      if (name.startsWith(this._qtyExpandName))
        delete rowData[name];
    }
  },

  _changeColumnCaption: function () {
    if (this._displayMode != Sys.UI.Controls.DressDisplayMode.standard || !this._dressMode) return;
    if (!this._standardTdBand) return;

    //得到转换后的数据源
    var list = this._lastList;
    if (!list || list.length == 0) return;

    //获取选中行数据
    var rowData = this.get_selectedRowData();
    rowData = rowData ? rowData : list[0];

    //获取指定商品的尺码数据
    var ptypeid = rowData[this._gridSetting.PtypeIdField];
    var sizeCache = this._getSizeCacheById(ptypeid);
    if (!sizeCache) return;
    var sizeCount = sizeCache.length;

    //获取尺码列信息
    var expandColumn = this._standardTdBand.expandColumn;
    var columns = expandColumn.expanded;
    var columnCount = columns.length;
    for (var i = 0; i < sizeCount && i < columnCount; i++) {
      var column = columns[i];
      column.set_caption(sizeCache[i]);
    }
    for (var i = sizeCount; i < columnCount; i++) {
      var column = columns[i];
      column.set_caption(" ");
    }
  },

  _doExpandData: function (supportsObjProp) {
    if (!this._dressMode) {
      return;
    }
    this._doInitSizeCache(); //将明细数据的尺码放到缓存

    this._doExpandDataSource(); //展开数据源

    this._saveDataSource(this._lastList, supportsObjProp); //调用Grid方法，绑定数据源
  },

  _doExpandDataSource: function () {
    if (this._gridSetting == null || !this._dressMode) return;

    if (this._displayMode == Sys.UI.Controls.DressDisplayMode.master) { //总量
      this._doMasterData();
      return;
    }

    if (this._displayMode == Sys.UI.Controls.DressDisplayMode.standard) { //标准
      this._doStandardData();
      return;
    }

    var data = this.getDressData(this._doIsChangedFromMode(Sys.UI.Controls.DressDisplayMode.standard) || this._doIsChangedFromMode(Sys.UI.Controls.DressDisplayMode.master));
    for (var i in data) {
      this._validateNumberColumnData(data[i]);
    }
    this._lastList = Object.clone(data);
  },

  //是否刚从某个状态变动
  _doIsChangedFromMode: function (fromDisplayMode) {
    if (!this._displayModeChanged) {
      return false;
    }

    return fromDisplayMode == this._lastDisplayMode;
  },

  _doExpandColumn: function () {
    if (this._gridSetting == null || !this._dressMode) return;

    if (this._displayMode == Sys.UI.Controls.DressDisplayMode.master) { //总量
      this.set_maxHeaderLevel(1);
      this._showSizeColorColumn(false);
      return;
    }

    if (this._displayMode == Sys.UI.Controls.DressDisplayMode.detail) { //明细
      this.set_maxHeaderLevel(1);
      this._showSizeColorColumn(true);
      //this._setQtyColumnReadonly(false); // 来回改来改去没有最优方案，一开始就该放开ReadOnly产品自行控制只读啊
      return;
    }

    if (this._displayMode == Sys.UI.Controls.DressDisplayMode.standard) { //标准
      this.set_maxHeaderLevel(2);
      this._showSizeColorColumn(true);
      this._doStandardColumn();
      //this._setQtyColumnReadonly(true); // 来回改来改去没有最优方案，一开始就该放开ReadOnly产品自行控制只读啊
      return;
    }
  },

  getDetailData: function (ignoreValidation) {
    return this.saveData(ignoreValidation);
  },

  saveData: function (ignoreValidation) {
    if (this._displayMode == Sys.UI.Controls.DressDisplayMode.master) { //总量
      return this.getDressData(true);
    }

    if (this._displayMode == Sys.UI.Controls.DressDisplayMode.detail) { //明细
      return this._gridSaveData(ignoreValidation);
    }

    if (this._displayMode == Sys.UI.Controls.DressDisplayMode.standard) { //标准
      return this.getDressData(true);
    }
  },

  _gridSaveData: function (ignoreValidation) {
    if (!this._dressMode) {
      return Carpa.Dress.DressBase.callBaseMethod(this, 'saveData', [ignoreValidation]);
    }
    if (this._dataBinding) {
      return this._dataCache;
    }
    var isReadOnly = this.get_readOnly();
    if (isReadOnly) {
      this.set_readOnly(false);
    }
    var value = Carpa.Dress.DressBase.callBaseMethod(this, 'saveData', [ignoreValidation]);
    this.set_readOnly(isReadOnly);
    return value;
  },

  _setQtyColumnReadonly: function (value) {
    var column = this.getColumn(this._gridSetting.QtyField);
    var defaultReadOnly = column.get_readOnly();
    //这里不控制，因为从明细到标准后，qtyfield变为只读，再切换回来就没变回来了
    //if(defaultReadOnly) return; // 产品可以控制只读状态
    column.set_readOnly(value); // 交给平台控制
  },

  _doStandardColumn: function () {
    var list = this._lastList; // 得到转换后的数据源
    if (!list || list.length == 0 || !this._dressMode) return;

    //显示颜色列
    this._showColorColumn(true);

    //隐藏尺码列
    this._showSizeColumn(false);

    //隐藏折扣，税率，单价列
    this._showOtherColumn(false);

    //改变表体的高度，因为表头新增了一行
    this._changeBodyHeight(true);

    //如果已经创建了尺码列
    if (this._standardTdBand) {
      this._showStandardColumn(true);
      return;
    }

    this._expandQtyColumns();
  },

  get_standardTdBand: function () {
    return this._standardTdBand;
  },

  _expandQtyColumns: function () {
    if (!this._dressMode) {
      return;
    }
    //获取明细中的尺码列
    var sizeColumn = this.findColumn(this._gridSetting.SizeNameField);
    var offsetIndex = sizeColumn.get_index();
    var sizeTd = sizeColumn.get_headerElement();

    //得到表头
    var table = this._header;
    var tBody = $common.getTableBody(table);
    var headerRow = tBody.firstChild;
    var maxSizeCount = this.get_maxSizeCount();
    if (maxSizeCount == 0) return;

    //创建band单元格，在现有尺码列前面插入尺码扩展列
    var columnWidth = 65;
    var newSizeBandTd = this._insertTd(sizeTd, 0, sizeTd.innerHTML, true);
    newSizeBandTd.align = 'center'; //强制扩展尺码列表头居中
    newSizeBandTd.width = (columnWidth) * maxSizeCount;
    newSizeBandTd.colSpan = maxSizeCount;
    this._standardTdBand = newSizeBandTd;

    //多表头，需要修改其他列的rowSpan值
    var tds = $common.getChildrenByTagName(headerRow, "td");
    for (var i = 0, count = tds.length; i < count; i++) {
      var td = tds[i];
      if (td == newSizeBandTd) continue;
      td.rowSpan = 2;
    }

    //创建尺码表头行
    var newHeaderRow = $common.createTr();
    newHeaderRow.className = 'GridHeaderRow';
    newHeaderRow.style.height = "20px";
    tBody.appendChild(newHeaderRow);

    //创建一个尺码表头单元格
    var templateTd = {
      width: columnWidth,
      align: "center",
      colSpan: 1,
      rowSpan: 1
    };
    var headerElement = this._createHeaderTd(templateTd, "", true);
    newHeaderRow.appendChild(headerElement);

    //表尾单元格
    var newFooterElement = null;
    var footerElement = sizeColumn.get_footerElement();
    if (footerElement) {
      newFooterElement = this._insertTd(footerElement, 0, "", false);
    }

    var changeHandler = $createDelegate(this, "raiseExpandQtyChange");
    //构造尺码列参数
    var params = {
      "type": Sys.UI.Controls.NumberColumn,
      "properties": {
        "name": "size_0",
        "dataField": "size_0",
        "allowResize": false, //动态扩展的尺码列不允许调整列宽
        "allowConfig": false, //动态扩展的尺码列不允许列配置
        "designCaption": "",
        "designWidth": columnWidth,
        "headerAlign": "center",
        "allowSort": this._sizeCacheCurPage ? false : true, // 数据库分页模式，不能排序
        "allowFilter": this._sizeCacheCurPage ? false : true, // 数据库分页模式，不能排序
        "textAlign": "right",
        "filterType": 1,
        "decimalPrecision": 14,
        "decimalScale": 4,
        "minValue": 0
      },
      "events": {
        "change": changeHandler
      }
    };

    //创建第一个尺码列
    var column = this._insertColumn(offsetIndex, params, "", "size_0", headerElement, newFooterElement);
    column.set_minValue(0);
    column.add_change(changeHandler);

    //按最大尺码数动态扩展其他尺码列
    var expandInfo = {};
    expandInfo.name = "sizeband";
    expandInfo.captions = [];
    expandInfo.dataFields = [];
    expandInfo.reportFields = [];

    for (var i = 0; i < maxSizeCount; i++) {
      Array.add(expandInfo.captions, "");
      Array.add(expandInfo.dataFields, this._getExpandFieldName(i));
      Array.add(expandInfo.reportFields, i + '');
    }

    this._expandColumn(column, expandInfo);

    this._standardTdBand.expandColumn = column; //记录，显示/隐藏尺码列的时候需要
  },

  _showOtherColumn: function (value) {

  },

  _showSizeColumn: function (value) {
    var sizeidField = this._gridSetting.SizeIdField;
    var sizenameField = this._gridSetting.SizeNameField;

    var sizeidColumn = this.findColumn(sizeidField);
    if (sizeidColumn) sizeidColumn.set_visible(value);

    var sizenameColumn = this.findColumn(sizenameField);
    if (sizenameColumn) sizenameColumn.set_visible(value);
  },

  _showColorColumn: function (value) {
    var coloridField = this._gridSetting.ColorIdField;
    var colornameField = this._gridSetting.ColorNameField;

    var coloridColumn = this.findColumn(coloridField);
    if (coloridColumn) coloridColumn.set_visible(value);

    var colornameColumn = this.findColumn(colornameField);
    if (colornameColumn) colornameColumn.set_visible(value);
  },

  _changeBodyHeight: function (value) {
    if (this._bodyChangedDisplayMode == this._displayMode || !this._dressMode) {
      return;
    }
    if (this._isChangeBodyHeight == value) {
      return;
    }
    this._isChangeBodyHeight = value;
    this._bodyChangedDisplayMode = this._displayMode;
    if (Sys.Browser.isIE && Sys.Browser.version < 9) return; //有点奇怪，必须这样才正常。没搞懂ie的特性
    if (this._body) {
      var height = this._body.offsetHeight;
      height = value ? height - 16 : height + 16;
      $common.setHeight(this._body, height);
    }
  },

  _showStandardColumn: function (value) {
    var table = this._header;
    var tBody = $common.getTableBody(table);
    var trs = $common.getChildrenByTagName(tBody, "tr");
    var expandTr = trs[1];
    if (!expandTr) return;
    //expandTr.style.display = value ? "" : "none";
    expandTr.style.height = value ? "21px" : "0px";
    if (this._standardTdBand) {
      this._standardTdBand.style.display = value ? "" : "none";

      var expandColumn = this._standardTdBand.expandColumn;
      var columns = expandColumn.expanded;
      var length = this.get_realMaxSizeCount() - columns.length;
      if (length > 0) {
        for (var i = columns.length; length > 0; length--) {
          var newColumn = this._addNewColumn(expandColumn, i, '', this._getExpandFieldName(i), i + '');
          newColumn._isExpandNew = true;
          columns[i] = newColumn;
          i++;
        }
        this._set_standardTdBandWidth(columns.length);
      }
      for (var i = 0, count = columns.length; i < count; i++) {
        var column = columns[i];
        column.set_visible(value);
        if (value && count + length <= i) { //隐藏多余的列
          column.set_visible(false);
        }
      }
      this._set_standardTdBandWidth(Math.min(count, count + length));
    }
  },

  _set_standardTdBandWidth: function (length) {
    var bandWidth = 65 * length;
    this._standardTdBand.style.width = bandWidth + 'px';
    try {
      this._standardTdBand.colSpan = length;
    } catch (e) {

    }
  },

  _showSizeColorColumn: function (value) {
    this._showColorColumn(value);
    this._showSizeColumn(value);

    if (this._lastDisplayMode == Sys.UI.Controls.DressDisplayMode.standard) { //处于普通模式
      this._changeBodyHeight(false);
      this._showStandardColumn(false);
    }
  },

  _doMasterData: function () {
    var dataSourceList = this.getDressData();
    var list = Object.clone(dataSourceList); //深拷贝
    var recordCount = list.length;
    var newList = [];
    var cacheList = new Array();

    var mergeFields = this.get_mergeFields();
    var itemsCache = [];
    var masterMergingHandler = this.get_events().getHandler("masterMerging");
    for (var i = 0; i < recordCount; i++) {
      var rowData = list[i];
      var ptypeid = rowData[this._gridSetting.PtypeIdField];

      if (rowData[this._gridSetting.PtypeIdField] != ptypeid) {
        continue;
      }

      var tempId = this._getPtypeId(ptypeid, mergeFields, rowData);

      //根据商品id查找同一商品下的数据
      if (Array.contains(cacheList, tempId)) {
        var index = Array.indexOf(cacheList, tempId);
        Array.add(itemsCache[index], rowData);
        continue;
      }

      var itemCache = [];
      Array.add(itemCache, rowData);
      Array.add(itemsCache, itemCache);
      Array.add(cacheList, tempId);

      this._doPtypeTotal(rowData, ptypeid, mergeFields, rowData, tempId); //统计指定商品的数量和金额
      this._validateNumberColumnData(rowData);
      newList.push(rowData);
    }

    if (masterMergingHandler) {
      for (var i = 0, count = newList.length; i < count; i++) {
        var mergingArgs = new Sys.UI.Controls.MasterMergingEventArgs(newList[i], itemsCache[i]);
        masterMergingHandler(this, mergingArgs);
      }
    }
    itemsCache = null;
    delete itemsCache;
    this._lastList = newList;
  },

  _getPtypeId: function (ptypeid, mergeFields, rowData) {
    var tempId = ptypeid;
    for (var j = 0, count = mergeFields.length; j < count; j++) {
      var mergeFieldItem = mergeFields[j];
      tempId += '_' + rowData[mergeFieldItem];
    }
    return tempId;
  },

  _doStandardData: function () {
    var dataSourceList = this.getDressData();
    var list = Object.clone(dataSourceList); //深拷贝
    var recordCount = list.length;
    var newList = [];
    var cacheList = new Array();

    var mergeFields = this.get_mergeFields();
    var standardMergingHandler = this.get_events().getHandler("standardMerging");
    var itemsCache = [];
    for (var i = 0; i < recordCount; i++) {
      var rowData = list[i];
      var ptypeid = rowData[this._gridSetting.PtypeIdField];
      var colorid = rowData[this._gridSetting.ColorIdField];

      //根据商品id和颜色id查找同一商品下的不同尺寸数量
      var cacheName = ptypeid + "_" + colorid;
      for (var j = 0, count = mergeFields.length; j < count; j++) {
        var mergeFieldItem = mergeFields[j];
        cacheName += '_' + rowData[mergeFieldItem];
      }
      if (Array.contains(cacheList, cacheName)) {
        var index = Array.indexOf(cacheList, cacheName);
        Array.add(itemsCache[index], rowData);
        continue;
      }
      var itemCache = [];
      Array.add(itemCache, rowData);
      Array.add(itemsCache, itemCache);
      Array.add(cacheList, cacheName);

      var sizeCache = this._getSizeCacheById(ptypeid);
      if (!sizeCache) {
        continue;
      }
      rowData["total_temp"] = rowData["qty_temp"] = 0;

      for (var j = 0, sCount = sizeCache.length; j < sCount; j++) {
        var ptypeSizeName = sizeCache[j];
        this._doSizeTotal(rowData, j, ptypeid, colorid, ptypeSizeName, mergeFields, rowData); //统计指定商品，相同颜色尺码的数量，总金额
      }

      var price = Math.roundTo(rowData["total_temp"] / rowData["qty_temp"], 4);
      var total = rowData["total_temp"];

      if (this._updateStandardDataQty)
        this._updateStandardDataQty(rowData);

      delete rowData["qty_temp"];
      delete rowData["total_temp"];
      newList.push(rowData);
    }

    if (standardMergingHandler) {
      for (var i = 0, count = newList.length; i < count; i++) {
        var mergingArgs = new Sys.UI.Controls.StandardMergingEventArgs(newList[i], itemsCache[i]);
        standardMergingHandler(this, mergingArgs);
      }
    }

    itemsCache = null;
    delete itemsCache;

    for (var i = 0, count = newList.length; i < count; i++) {
      this._validateNumberColumnData(newList[i]);
    }
    this._lastList = newList;
  },

  _doDetailData: function () {
    var list = [];
    var dataList = this._gridSaveData();
    if (!dataList) {
      return list;
    }

    for (var i = 0; i < dataList.length; i++) {
      var rowData = dataList[i];
      var ptypeid = rowData[this._gridSetting.PtypeIdField];
      var sizeCache = this._getSizeCacheById(ptypeid);
      var price = rowData[this._gridSetting.PriceField];

      var discount = rowData[this._gridSetting.DiscountField];
      var discountPrice = rowData[this._gridSetting.DiscountPriceField];

      var tax = rowData[this._gridSetting.TaxField];
      var taxPrice = rowData[this._gridSetting.TaxPriceField];

      var newData = true; //原有数据
      for (var dataField in rowData) {
        if (!dataField.startsWith(this._qtyExpandName)) {
          continue;
        }
        newData = false;
        var pos = dataField.substr(this._qtyExpandName.length + 1);
        var sizeName = sizeCache[pos];
        var qty = rowData[dataField];
        /*if(qty === 0){
        continue;
        }*/
        //保留数量为0的数据
        list.push(this._bindDetailData(price, qty, sizeName, tax, taxPrice, discount, discountPrice, ptypeid, rowData));
      }
      if (newData) { //当前新增操作数据
        for (var j = 0, sCount = sizeCache ? sizeCache.length : 0; j < sCount; j++) {
          var sizeName = sizeCache[j];

          //通过选择添加的行，直接筛选非选择尺码
          /*f (rowData[this._gridSetting.SizeNameField] && sizeCache[j] && rowData[this._gridSetting.SizeNameField].toUpperCase() != sizeCache[j].toUpperCase()) {
          continue;
          }*/

          if (rowData[this._gridSetting.SizeNameField] && sizeCache[j] &&
            rowData[this._gridSetting.SizeNameField] != sizeCache[j]) {
            continue;
          }
          var qty = rowData[this._gridSetting.QtyField];
          if (qty === 0) {
            continue;
          }
          list.push(this._bindDetailData(price, qty, sizeName, tax, taxPrice, discount, discountPrice, ptypeid, rowData));
        }
      }
    }
    return list;
  },

  _bindDetailData: function (price, qty, sizeName, tax, taxPrice, discount, discountPrice, ptypeid, rowData) {
    var record = Object.clone(rowData);
    this._clearQtyExpandItem(record)
    record[this._gridSetting.PtypeIdField] = ptypeid;
    record[this._gridSetting.PfullnameField] = rowData[this._gridSetting.PfullnameField];
    record[this._gridSetting.ColorIdField] = rowData[this._gridSetting.ColorIdField];
    record[this._gridSetting.ColorNameField] = rowData[this._gridSetting.ColorNameField];
    record[this._gridSetting.SizeIdField] = this._getSizeIdByName(sizeName);
    record[this._gridSetting.SizeNameField] = sizeName;

    record[this._gridSetting.QtyField] = qty;
    record[this._gridSetting.PriceField] = price;

    this._validateNumberColumnData(record);
    if (this._updateRowData)
      this._updateRowData(record);
    return record;
  },

  _doPtypeTotal: function (recordInfo, ptypeid, mergeFields, rowData, tempId) {
    var list = this.getDressData();
    var recordCount = list.length;
    var qtyTotal = 0;
    var sumTotal = 0;

    for (var i = 0; i < recordCount; i++) {
      var rowData = list[i];
      if (rowData[this._gridSetting.PtypeIdField] != ptypeid) {
        continue;
      }
      var pid = this._getPtypeId(ptypeid, mergeFields, rowData);

      if (pid != tempId) continue;
      var qty = rowData[this._gridSetting.QtyField];
      if (qty) qtyTotal += qty;

      var total = rowData[this._gridSetting.TotalField];
      if (total && total != 0) { //如果不存在合计价格
        sumTotal += total;
      } else {
        var price = rowData[this._gridSetting.PriceField];
        if (price)
          sumTotal += (price * qty);
      }
    }

    //TODO 如果存在 空tsumTotal
    var price = Math.roundTo(sumTotal / qtyTotal, 4);
    recordInfo[this._gridSetting.PriceField] = price;
    recordInfo[this._gridSetting.QtyField] = qtyTotal;
    recordInfo[this._gridSetting.TotalField] = sumTotal;

    if (this._updateRowData)
      this._updateRowData(recordInfo);
  },

  _doSizeTotal: function (recordinfo, offset, ptypeid, colorid, sizename, mergeFields, currentRowData) {
    var list = this.getDressData();
    var recordCount = list.length;
    var qtyTotal = 0;
    var sumTotal = 0;
    for (var i = 0; i < recordCount; i++) {
      var rowData = list[i];
      var ptypeid1 = rowData[this._gridSetting.PtypeIdField];
      var colorid1 = rowData[this._gridSetting.ColorIdField];
      var sizename1 = rowData[this._gridSetting.SizeNameField];

      var isContinue = true;
      for (var j = 0, count = mergeFields.length; j < count; j++) {
        var item = mergeFields[j];
        if (rowData[item] != currentRowData[item]) {
          isContinue = false;
          break;
        }
      }
      if (!isContinue || ptypeid1 != ptypeid || colorid1 != colorid || sizename1 != sizename) continue;

      var qty = rowData[this._gridSetting.QtyField];
      if (qty) qtyTotal += qty;

      var total = rowData[this._gridSetting.TotalField];
      if (total) sumTotal += total;
    }
    if (qtyTotal === 0) {
      return;
    }
    recordinfo[this._getExpandFieldName(offset)] = qtyTotal;
    //recordinfo["total_temp"] += sumTotal;
    //recordinfo["qty_temp"] += qtyTotal;
  },

  _getExpandFieldName: function (index) {
    return this._qtyExpandName + "_" + index;
  },

  _getSizeCacheById: function (ptypeid) {
    if (!this._sizeInfoListCache || !this._sizeInfoListCache[ptypeid]) {
      this._doInitSizeCache();
    }
    return this._sizeInfoListCache[ptypeid];
  },

  _doInitSizeCache: function () {
    var list = this._getSizeData();
    if (this._sizeInfoListCache != null) {
      for (var i in this._sizeInfoListCache) {
        Array.clear(this._sizeInfoListCache[i]);
        delete this._sizeInfoListCache[i];
      }
    }

    var recordCount = list ? list.length : 0;
    for (var i = 0; i < recordCount; i++) {
      var rowData = list[i];
      this._addSizeGroupToCache(rowData);

      //当没有尺码组时候通过记录的尺码信息获取
      if (!rowData[this._gridSetting.SizeNameField])
        continue;
      var ptypeid = rowData[this._gridSetting.PtypeIdField];
      var sizename = rowData[this._gridSetting.SizeNameField];
      var sizeid = rowData[this._gridSetting.SizeIdField];
      if (!this._sizeInfoListCache[ptypeid]) this._sizeInfoListCache[ptypeid] = new Array();
      if (!Array.contains(this._sizeInfoListCache[ptypeid], sizename)) Array.add(this._sizeInfoListCache[ptypeid], sizename);
      if (!this._sizeIdCache) this._sizeIdCache = {};
      if (!this._sizeIdCache[sizename]) this._sizeIdCache[sizename] = sizeid;
    }

    if (this.get_displayMode() == Sys.UI.Controls.DressDisplayMode.standard) {
      var standardSizeSortHandler = this.get_events().getHandler("standardSizeSort");
      if (standardSizeSortHandler) {
        var eventArgs = new Sys.UI.Controls.StandardSizeSortEventArgs(this._sizeInfoListCache);
        standardSizeSortHandler(this, eventArgs);
        this._sizeInfoListCache = eventArgs.get_sizes();
      }
    }
  },

  _getSizeData: function () {
    if (!this.get_isInitialized()) {
      return [];
    }
    var list = this._gridSaveData();
    list = list ? list : [];
    if (!this._displayModeChanged && this._displayMode == Sys.UI.Controls.DressDisplayMode.standard) {
      var newList = [];
      for (var i = 0, recordCount = list.length; i < recordCount; i++) {
        var rowData = list[i];
        var ptypeid = rowData[this._gridSetting.PtypeIdField];
        var sizename = rowData[this._gridSetting.SizeNameField];
        var sizeid = rowData[this._gridSetting.SizeIdField];
        if (!this._sizeInfoListCache[ptypeid]) {
          newList.push(Object.clone(list[i]));
          continue;
        }
        var sizes = this._sizeInfoListCache[ptypeid];
        for (var j = 0, count = sizes.length; j < count; j++) {
          var newItem = Object.clone(rowData);
          newList.push(newItem);
          if (typeof (rowData[this._getExpandFieldName(j)]) == 'undefined') {
            break;
          }
          newItem[this._gridSetting.SizeNameField] = sizes[j];
          newItem[this._gridSetting.SizeIdField] = this._getSizeIdByName(sizes[j]);
        }
      }
      return newList;
    }
    //if (this._lastDisplayMode == Sys.UI.Controls.DressDisplayMode.master || this._lastDisplayMode == Sys.UI.Controls.DressDisplayMode.detail) {
    if (this._lastDisplayMode == Sys.UI.Controls.DressDisplayMode.master) {
      list = this.getDressData();
    }
    return list;
  },

  _getSizeIdByName: function (sizeName) {
    return this._sizeIdCache[sizeName];
  },

  /*获取最大尺码数*/
  get_maxSizeCount: function () {
    var maxSizeCount = this._maxSizeCount;
    if (maxSizeCount == 0) {
      for (var size in this._sizeInfoListCache) {
        var sizeCache = this._sizeInfoListCache[size];
        if (sizeCache.length > maxSizeCount) {
          maxSizeCount = sizeCache.length;
        }
      }
      this._maxSizeCount = maxSizeCount; //取一次就记录下来
    }
    return maxSizeCount;
  },
  set_maxSizeCount: function (value) {
    this._maxSizeCount = value;
  },
  get_realMaxSizeCount: function () {
    this.set_maxSizeCount(0);
    return this.get_maxSizeCount();
  },

  /* 保存从服务器端传来的尺码缓存数据  分页Grid需要 */
  get_sizeInfoListCache: function () {
    return this._sizeInfoListCache;
  },
  set_sizeInfoListCache: function (value) {
    this._sizeInfoListCache = value;
    if (!this.get_isInitialized()) return;
    this._sizeCacheChanged = true;
  },

  get_sizeInfoListCurPage: function () {
    return this._sizeInfoListCache;
  },
  set_sizeInfoListCurPage: function (value) {
    this._sizeInfoListCache = value;
    this._sizeCacheCurPage = true; // 标记当前的尺码缓存为当前页
    if (!this.get_isInitialized()) return;

    this._sizeCacheChanged = true;
  },

  set_sizeCacheCurPage: function (value) {
    this._sizeCacheCurPage = value; // 标记当前的尺码缓存为当前页
  },
  get_sizeCacheCurPage: function () {
    return this._sizeCacheCurPage;
  },

  /*获取DressGrid标准表格打印时需要显示对应行数据尺寸的captions*/
  get_columnRealCaption: function (index, defaultValue) {
    if (!this._standardTdBand || !this._standardTdBand.expandColumn) {
      return defaultValue;
    }
    var sizeCache = this.get_sizeInfoListCache();
    var sb = new Sys.StringBuilder();
    var items = [];
    for (var i in sizeCache) {
      var item = sizeCache[i][index];
      if (typeof (item) === 'undefined') {
        continue;
      }
      sb.append("\r\n" + item);
    }
    if (sb.toString().length == 0) {
      return defaultValue;
    }

    return sb.toString().substring(2);
  },

  /*客户端记录服装Grid的设置信息*/
  get_gridSetting: function () {
    return this._gridSetting;
  },
  set_gridSetting: function (value) {
    if (this.get_isInitialized()) return; //初始化之后不允许改变设置
    this._gridSetting = value;
  },

  /*显示模式*/
  get_displayMode: function () {
    return this._displayMode;
  },
  set_displayMode: function (value) {
    if (this._displayMode == value) return;
    this._set_displayMode(value);

  },

  _set_displayMode: function (value) {
    this._lastDisplayMode = this._displayMode;

    if (this._displayMode == Sys.UI.Controls.DressDisplayMode.detail || this._displayMode == Sys.UI.Controls.DressDisplayMode.master) {
      this._detailsData = this._dataSource;
    }

    this._displayMode = value;
    if (!this.get_isInitialized()) return;
    this._displayModeChanged = true;
    this.clearSortFlag(); //切换格式之后，显示的列已不相同，原来的排序不再有效

    var pager = this.findPager();
    if (pager) {
      this._doExpandColumn(); //展开列

      var params = new Object(); //将显示模式传到服务端，从新转换数据
      params.Command = "UpdateMode";
      params.Data = value;
      pager._internalRefreshState(params);
      return;
    }

    this._doExpandData(true); //展开数据

    this._doExpandColumn(); //如果已经初始化则根据数据源动态展开和折叠列

    this._refreshFrozenHeaderHeight();
    this._scrollToTop();

    this.dataChanged(); //更新表格
    this._displayModeChanged = false;
    this._dataSource = this._lastList;
		/*       if (this._detailsData == null && this._displayMode == Sys.UI.Controls.DressDisplayMode.detail) {
		           this._detailsData = this._dataSource;
		       }*/
    var _this = this;
    window.asyncCall(function () {
      _this._isModify = false;
    });
  },

  //刷新模式，只支持单据
  _refresh_displayMode: function () {
    this.clearSortFlag();
    this._doExpandData(true);
    this._doExpandColumn();
    this.dataChanged();
  },

  _showDiscount: function () {
    return (this._gridSetting.DiscountField != "" &&
      this._gridSetting.DiscountPriceField != "" &&
      this._gridSetting.DiscountTotalField != "");
  },

  _showTax: function () {
    return (this._gridSetting.TaxField != "" &&
      this._gridSetting.TaxPriceField != "" &&
      this._gridSetting.TaxTotalField != "");
  },

  /************************************************************************/
  /* 事件                                                                 */
  /************************************************************************/
  _createChangeHandler: function (name, eventName) {
    var column = this.findColumn(name);
    if (!column) return;

    var handler = $createDelegate(this, eventName);
    column.add_change(handler);
  },

  _bindColumnsEvent: function () {
    if (this._hasPager()) return; //翻页的dressgrid不支持编辑，因为不需要绑定事件

    var columnArray = [];
    //所有列添加变动事件
    var columns = this.get_columns();
    for (var i = 0; i < columns.length; i++) {
      columnArray.push(columns[i].get_dataField());
    }


    for (var i = 0; i < columnArray.length; i++) {
      this._createChangeHandler(columnArray[i], 'commonColumnChange');
    }
  },

  commonColumnChange: function (sender, eventArgs) {
    try {
      var rowData = this.get_selectedRowData();
      this.modifySelectedRowData(rowData, sender, eventArgs);
    } catch (e) {

    }
  },

  /*重写*/
  _doModifyRowData: function (rowIndex, data) {
    if (!this._dressMode) {
      Carpa.Dress.DressBase.callBaseMethod(this, '_doModifyRowData', [rowIndex, data]);
      return;
    }
    this._isModifyRowIndex = Object.isEmpty(data) ? -1 : rowIndex;
    //this._validateNumberColumnData(data);
    var newData = Object.clone(data);
    var ptypeid = newData[this._gridSetting.PtypeIdField];
    var colorid = newData[this._gridSetting.ColorIdField];
    var sizename = newData[this._gridSetting.SizeNameField];

    this._newPtypeFlag = this._getNewPtypeFlag(ptypeid, colorid);

    //this._validateNumberColumnData(data);

    if (this._displayMode == Sys.UI.Controls.DressDisplayMode.standard) {
      this._doModifyOrAddDetailData(newData, rowIndex);
      this._modifyColumn = null;
      this._modifyEventArgs = null;
    } else if (this._displayMode == Sys.UI.Controls.DressDisplayMode.detail) {
      Carpa.Dress.DressBase.callBaseMethod(this, '_doModifyRowData', [rowIndex, data]);
      this._isModify = true;
      //this._refresh_displayMode();//放开后会导致修改数据时，焦点跑到第二行上去
      this._newPtypeFlag = null;
    } else if (this._displayMode == Sys.UI.Controls.DressDisplayMode.master) {
      this._doModifyOrAddDetailData(newData, rowIndex);
      this._modifyColumn = null;
      this._modifyEventArgs = null;
    }
  },

  /*检查不合并的字段*/
  _checkNotMergeRow: function (tempdata, mergeFields, data, columnName, oldValue) {
    if (mergeFields == null)
      return true;
    var count = mergeFields.length;
    for (var i = 0; i < count; i++) {
      var fidldName = mergeFields[i];
      if (columnName != null &&
        fidldName == columnName &&
        typeof (oldValue) != "undefined" &&
        tempdata[columnName] == oldValue)
        continue;
      if (tempdata[fidldName] != data[fidldName])
        return false;
    }
    return true;
  },

  get_mergeFields: function () {
    var mergeFields = [];
    var handler = null;
    if (this._displayMode == Sys.UI.Controls.DressDisplayMode.master) {
      handler = this.get_events().getHandler("masterMerge");
      if (handler) {
        var eventArgs = new Sys.UI.Controls.MasterMergeEventArgs();
        handler(this, eventArgs);
        mergeFields = eventArgs.get_mergeFields();
      }
    } else if (this._displayMode == Sys.UI.Controls.DressDisplayMode.standard) {
      handler = this.get_events().getHandler("standardMerge");
      if (handler) {
        var eventArgs = new Sys.UI.Controls.StandardMergeEventArgs();
        handler(this, eventArgs);
        mergeFields = eventArgs.get_mergeFields();
      }
    }
    return mergeFields;
  },

  /*新增或修改尺码明细数据*/
  _doModifyOrAddDetailData: function (data, rowIndex) {
    //处理标准视图下多表头问题
    this._doModifySizeQty(data, rowIndex);

    var focusedColumn = this._modifyColumn;
    var columnName = focusedColumn.get_dataField();

    if (this._displayMode == Sys.UI.Controls.DressDisplayMode.master) {
      handler = this.get_events().getHandler("masterModifyMerge");
      if (handler) {
        var eventArgs = new Sys.UI.Controls.MasterModifyMergeEventArgs();
        handler(this, eventArgs);
        this._isModify = eventArgs.get_isModify();
      } else
        this._isModify = false;
    } else
      this._isModify = true;

    this._newPtypeFlag = null;

    //处理除多表头外的数据编辑
    this._addOrUpdateDetailsData(data, rowIndex, columnName);

    //更新界面数据
    Carpa.Dress.DressBase.callBaseMethod(this, '_doModifyRowData', [rowIndex, data]);
  },

  /*新增或修改尺码明细数据*/
  _doModifySizeQty: function (data, rowIndex) {
    if (this._displayMode == Sys.UI.Controls.DressDisplayMode.standard) {
      var focusedColumn = this._modifyColumn;
      var columnName = focusedColumn.get_dataField();
      var sizeQtyColumnName = focusedColumn.get_dataField();

      //判断非尺码列
      if (!sizeQtyColumnName.startsWith(this._qtyExpandName)) {
        return;
      }

      var e = new Object();
      e.focusedColumn = focusedColumn;
      var ptypeid = data[this._gridSetting.PtypeIdField];
      var colorid = data[this._gridSetting.ColorIdField];
      var recordList = this.getDressData();
      var sizeName = focusedColumn.get_designReportCaption();
      var tempData = null;

      var mergeFields = this.get_mergeFields();

      var count = recordList.length;
      //查询存在的记录并修改
      for (var j = 0; j < count; j++) {
        var oldptypeid = recordList[j][this._gridSetting.PtypeIdField];
        var oldcolorid = recordList[j][this._gridSetting.ColorIdField];
        var oldSizeName = recordList[j][this._gridSetting.SizeNameField];
        //存放一个临时对象，用于新增
        if (tempData == null &&
          oldptypeid == ptypeid &&
          oldcolorid == colorid) {
          //判断合并列
          var length = mergeFields.length;
          var isAdd = true;
          for (var i = 0; i < length; i++) {
            var fidldName = mergeFields[i];
            if (recordList[j][fidldName] != data[fidldName]) {
              isAdd = false;
              break;
            }
          }
          if (isAdd)
            tempData = Object.clone(recordList[j]); //拷贝临时数据
        }

        if (oldptypeid == ptypeid &&
          oldcolorid == colorid &&
          sizeName == oldSizeName &&
          recordList[j][this._gridSetting.QtyField] != data[sizeQtyColumnName] &&
          this._checkNotMergeRow(recordList[j], mergeFields, data)) {
          recordList[j][this._gridSetting.QtyField] = data[sizeQtyColumnName];
          this.doChange(e);
          return; //修改完成退出
        }
      }

      if (data[sizeQtyColumnName] == 0) //数量为0，不添加记录
        return;

      if (tempData == null) {
        var value = this.get_selectedRowData();
        tempData = new Object();
        for (var name in value) {
          if (name.startsWith(this._qtyExpandName))
            continue;
          tempData[name] = value[name];
        }
      }
      tempData[this._gridSetting.SizeNameField] = sizeName; //修改尺码
      tempData[this._gridSetting.QtyField] = data[sizeQtyColumnName]; //修改数量
      tempData[this._gridSetting.SizeIdField] = this._sizeIdCache[sizeName];
      recordList.push(tempData);
    }
  },

  /*在修改尺码列数量时检查是否存在多个明细，并做移除*/
  _removeMoreDetailsData: function (data, mergeFields, newSizeQtyColumnName, columnName, oldValue, startIndex) {
    var detailsData = this._detailsData;
    var count = detailsData.length;
    for (var k = count - 1; k > startIndex; k--) {
      var tempdata = detailsData[k];
      var oldptypeid = tempdata[this._gridSetting.PtypeIdField];
      var oldcolorid = tempdata[this._gridSetting.ColorIdField];
      var oldSizeName = tempdata[this._gridSetting.SizeNameField];
      var oldSizeIndex = this._getSizeIdByName(oldSizeName);
      var oldsizeQtyColumnName = this._getExpandFieldName(oldSizeIndex);
      if (oldptypeid == data[this._gridSetting.PtypeIdField] &&
        oldcolorid == data[this._gridSetting.ColorIdField] &&
        oldsizeQtyColumnName == newSizeQtyColumnName &&
        oldsizeQtyColumnName == columnName &&
        this._checkNotMergeRow(tempdata, mergeFields, data, columnName, oldValue)) {
        detailsData.splice(k, 1);
      }
    }
  },

  /*添加或更新明细数据*/
  _addOrUpdateDetailsData: function (data, rowIndex, columnName) {
    if (this._displayMode == Sys.UI.Controls.DressDisplayMode.standard) {
      var mergeFields = this.get_mergeFields();
      var oldValue = undefined;
      if (this._modifyEventArgs != null)
        oldValue = this._modifyEventArgs.get_oldValue();
      var sizeGroup = data[this._gridSetting.SizeGroupFieId];
      for (var sizeid in sizeGroup) {
        var add = true;
        var detailsData = this._detailsData;
        var count = detailsData.length;
        var newSizeQtyColumnName = this._getExpandFieldName(sizeid);
        for (var i = 0; i < count; i++) {
          //因为下面会移除，所以必须判断
          if (detailsData.length <= i)
            break;

          var tempdata = detailsData[i];
          var oldptypeid = tempdata[this._gridSetting.PtypeIdField];
          var oldcolorid = tempdata[this._gridSetting.ColorIdField];
          var oldSizeName = tempdata[this._gridSetting.SizeNameField];
          var oldSizeIndex = this._getSizeIdByName(oldSizeName);
          var oldsizeQtyColumnName = this._getExpandFieldName(oldSizeIndex);

          if (oldptypeid == data[this._gridSetting.PtypeIdField] &&
            oldcolorid == data[this._gridSetting.ColorIdField] &&
            oldsizeQtyColumnName == newSizeQtyColumnName &&
            this._checkNotMergeRow(tempdata, mergeFields, data, columnName, oldValue)) {

            if (columnName == oldsizeQtyColumnName) //只移除当前列冲突元素
              this._removeMoreDetailsData(data, mergeFields, newSizeQtyColumnName, columnName, oldValue, i);

            if (columnName == newSizeQtyColumnName)
              tempdata[this._gridSetting.QtyField] = data[newSizeQtyColumnName];
            else
              tempdata[columnName] = data[columnName];

            if (this._updateRowData)
              this._updateRowData(tempdata);
            add = false;
          }
        }
        if (add) {
          if (data[newSizeQtyColumnName] == null)
            continue;
          var tData = Object.clone(data);
          tData[this._gridSetting.SizeIdField] = sizeid;
          tData[this._gridSetting.SizeNameField] = sizeGroup[sizeid];
          if (columnName.startsWith(this._qtyExpandName) && data[newSizeQtyColumnName] != null)
            tData[this._gridSetting.QtyField] = data[newSizeQtyColumnName];
          if (this._updateRowData)
            this._updateRowData(tData);
          detailsData[detailsData.length] = tData;
        }
      }
    }
  },

  _addSizeGroupToCache: function (data) {
    //写入新数据说对应的缓存
    var sizegroup = data[this._gridSetting.SizeGroupFieId];
    if (sizegroup != null) {
      var ptypeid = data[this._gridSetting.PtypeIdField];
      for (var sizeid in sizegroup) {
        var sizename = sizegroup[sizeid];
        sizename = sizename.toString();
        if (!this._sizeInfoListCache[ptypeid]) this._sizeInfoListCache[ptypeid] = new Array();
        if (!Array.contains(this._sizeInfoListCache[ptypeid], sizename)) Array.add(this._sizeInfoListCache[ptypeid], sizename);
        if (!this._sizeIdCache) this._sizeIdCache = {};
        if (!this._sizeIdCache[sizename]) this._sizeIdCache[sizename] = sizeid;
      }
    }
  },

  appendRowData: function (data, disableSetAsSelected) {
    if (this._displayMode == Sys.UI.Controls.DressDisplayMode.master)
      return;

    if (this._updateRowData)
      this._updateRowData(data);

    this._dataCache.push(data);
    if (this._displayMode == Sys.UI.Controls.DressDisplayMode.standard) {
      this._addSizeGroupToCache(data);
      Carpa.Dress.DressBase.callBaseMethod(this, 'appendRowData', [data, disableSetAsSelected]);
      this._isModify = false;
      this._set_displayMode(Sys.UI.Controls.DressDisplayMode.standard);
    } else {
      Carpa.Dress.DressBase.callBaseMethod(this, 'appendRowData', [data, disableSetAsSelected]);
    }
  },

  dataBind: function (data) {
    this._detailsData = data;
    if (this._displayMode == Sys.UI.Controls.DressDisplayMode.master) {
      var _this = this;
      window.asyncCall(function () {
        Carpa.Dress.DressBase.callBaseMethod(_this, 'dataBind', [data]);
      });
    } else {
      Carpa.Dress.DressBase.callBaseMethod(this, 'dataBind', [data]);
    }
  },

	/**
	 * 根据索引取得特定行的数据对象，无效的行索引则抛出异常
	 * @public
	 */
  getRowData: function (rowIndex, isDetail, notBelong) {
    if (isDetail &&
      (this._displayMode == Sys.UI.Controls.DressDisplayMode.standard ||
        this._displayMode == Sys.UI.Controls.DressDisplayMode.master)) {
      var rowData = Carpa.Dress.DressBase.callBaseMethod(this, "getRowData", [rowIndex]);
      var ptypeid = rowData[this._gridSetting.PtypeIdField];
      var mergeFields = this.get_mergeFields();
      var recordList = this.getDressData();
      var newRowDataList = new Array();
      for (var i = 0, length = recordList.length; i < length; i++) {
        var tempData = recordList[i];
        if (notBelong) { //如果需要不属于的项
          if (!(tempData[this._gridSetting.PtypeIdField] === ptypeid &&
            this._checkNotMergeRow(tempData, mergeFields, rowData)))
            newRowDataList.push(tempData);
        } else if (tempData[this._gridSetting.PtypeIdField] === ptypeid &&
          this._checkNotMergeRow(tempData, mergeFields, rowData)) {
          newRowDataList.push(tempData);
        }
      }
      return newRowDataList;
    } else {
      return Carpa.Dress.DressBase.callBaseMethod(this, "getRowData", [rowIndex]);
    }
  },

	/**
	 * 删除特定行
	 * @public
	 */
  deleteRow: function (rowIndex, noSelected) {
    if (this._displayMode == Sys.UI.Controls.DressDisplayMode.standard ||
      this._displayMode == Sys.UI.Controls.DressDisplayMode.master) {
      var dataSource = this.get_dataSource();
      if (dataSource.length == 0)
        return;
      var rowDatas = this.getRowData(rowIndex, true, true);
      this._dataCache = rowDatas;
      Carpa.Dress.DressBase.callBaseMethod(this, "deleteRow", [rowIndex, noSelected]);
      /*   this._isModify = false;*/
    } else {
      Carpa.Dress.DressBase.callBaseMethod(this, "deleteRow", [rowIndex, noSelected]);
    }
  },

  //获取尺码偏移量
  _getSizeCachePos: function (data) {
    var ptypeid = data[this._gridSetting.PtypeIdField];
    var sizename = data[this._gridSetting.SizeNameField];
    var sizeGruop = this._sizeInfoListCache[ptypeid];
    if (sizeGruop) {
      var count = sizeGruop.length;
      for (var i = 0; i < count; i++) {
        if (sizeGruop[i] == sizename)
          return i;
      }
    }
    return -1;
  },

  ChangeExistPtype: function () {
    this._changeExistPtype = true;
  },

  /*重写*/
  _internalCheckDeleteRow: function (rowIndex) {
    if (Carpa.Dress.DressBase.callBaseMethod(this, '_internalCheckDeleteRow', [rowIndex]) &&
      this.get_displayMode() == Sys.UI.Controls.DressDisplayMode.detail) {
      this._isModify = true;
    }
  },

  _getNewPtypeFlag: function (ptypeid, colorid) {
    return ptypeid + '_' + colorid;
  },

  _focusModifyRowData: function (ptypeid, colorid, sizename, delayfocus) {
    var newData = this._gridSaveData();
    var dataCacheName = ptypeid + "_" + colorid;
    var _this = this;
    for (var i = 0, count = newData.length; i < count; i++) {
      var rowData = newData[i]
      var nptypeid = rowData[this._gridSetting.PtypeIdField];
      var ncolorid = rowData[this._gridSetting.ColorIdField];

      //根据商品id和颜色id查找同一商品下的不同尺寸数量
      var cacheName = nptypeid + "_" + ncolorid;
      if (cacheName == dataCacheName) { //定位到哪一行
        var sizeCache = this._getSizeCacheById(nptypeid);
        var pos = Array.indexOf(sizeCache, sizename);
        if (pos < 0) {
          if (delayfocus) {
            break;
          }
          window.asyncCall(function () {
            _this._focusModifyRowData(ptypeid, colorid, sizename, true);
          });
          break;
        }
        this.set_selectedRowIndex(i);
        var column = this.get_columns()[this._standardTdBand.expandColumn.get_index() + pos];
        window.asyncCall(function () {
          _this.focusRowColumn(i, column); //定位到哪一列
        });
        return false; //直接定位到原有数据，取消修改
      }
    }
    if (!delayfocus) {
      window.asyncCall(function () {
        _this._focusModifyRowData(ptypeid, colorid, sizename, true);
      });
    }
    return true;
  },

  _validateNumberColumnData: function (data) {
    this._validateFieldData(this._gridSetting.QtyField, data);
    this._validateFieldData(this._gridSetting.PriceField, data);
    this._validateFieldData(this._gridSetting.TotalField, data);
    this._validateFieldData(this._gridSetting.DiscountField, data);
    this._validateFieldData(this._gridSetting.DiscountPriceField, data);
    this._validateFieldData(this._gridSetting.DiscountTaxPriceField, data);
    this._validateFieldData(this._gridSetting.DiscountTotalField, data);
    this._validateFieldData(this._gridSetting.TaxField, data);
    this._validateFieldData(this._gridSetting.TaxPriceField, data);
    this._validateFieldData(this._gridSetting.TaxTotalField, data);
    this._validateFieldData(this._gridSetting.LastTotalField, data);
  },

  _validateFieldData: function (dataField, data) {
    if (!data || typeof (data[dataField]) == 'undefined' || typeof (data[this._gridSetting.PtypeIdField]) == 'undefined') {
      return false;
    }
    if (isNaN(data[dataField])) {
      data[dataField] = 0;
    }
    return true;
  },

  /*重写*/
  _doCellBeginEdit: function (column, cell, row) {
    if (!this._dressMode) {
      return Carpa.Dress.DressBase.callBaseMethod(this, '_doCellBeginEdit', [column, cell, row])
    }

    if (this.get_displayMode() == Sys.UI.Controls.DressDisplayMode.standard && column.get_dataField() == this._gridSetting.QtyField) return false;

    //总量模式不允许编辑
    //wg确认标准和总量模式下，单元格不能编辑
    //if (this._displayMode == Sys.UI.Controls.DressDisplayMode.master || this._displayMode == Sys.UI.Controls.DressDisplayMode.standard) return false;
    if (this._displayMode == Sys.UI.Controls.DressDisplayMode.master && column.get_dataField() == this._gridSetting.QtyField) return false;

    var rowIndex = row ? this._getRowIndex(row) : this.get_selectedRowIndex();
    var isEmptyRow = this.isEmptyRow(rowIndex);
		/*if (column.get_dataField() != this._gridSetting.PtypeIdField && isEmptyRow) {
		return false;
		}*/
    var field = column.get_dataField();
    if (field && field.startsWith(this._qtyExpandName) && !isEmptyRow) {
      if (field.length < this._qtyExpandName.length + 1) {
        return false; //不是合法的尺码列dataField
      }
      var no = field.substr(this._qtyExpandName.length + 1)
      var rowData = this.getRowData(rowIndex);
      //尺码列
      var ptypeid = rowData[this._gridSetting.PtypeIdField];
      var sizeCache = this._getSizeCacheById(ptypeid);
      if (parseInt(no) >= sizeCache.length) {
        return false; //后面的尺码不属于很行，不能编辑
      }
    }

    var editable = Carpa.Dress.DressBase.callBaseMethod(this, '_doCellBeginEdit', [column, cell, row]);
    return editable;
  },

  modifySelectedRowData: function (rowData, sender, eventArgs) {
    this._modifyColumn = sender;
    this._modifyEventArgs = eventArgs;
    Carpa.Dress.DressBase.callBaseMethod(this, 'modifySelectedRowData', [rowData])
  },

  /*扩展的尺码数量列的change事件*/
  raiseExpandQtyChange: function (sender, eventArgs) {
		/*  var oldValue = eventArgs.get_oldValue();
		  if (typeof(oldValue) == 'undefined')
		      oldValue = 0;*/

    var rowData = this.get_selectedRowData();

    this.doStandardChanging(rowData, this._gridSetting.QtyField);

    this.modifySelectedRowData(rowData, sender, eventArgs);
  },

  add_standardChanging: function (handler) {
    this.get_events().addHandler("standardChanging", handler);
  },

  remove_standardChanging: function (handler) {
    this.get_events().removeHandler("standardChanging", handler);
  },

  doStandardChanging: function (rowData, changingField) {
    var handler = this.get_events().getHandler("standardChanging");
    if (handler) {
      var eventArgs = new Sys.UI.Controls.StandardItemChangeEventArgs(rowData, changingField);
      handler(this, eventArgs);
    }
  },

  add_masterModifyMerge: function (handler) {
    this.get_events().addHandler("masterModifyMerge", handler);
  },

  remove_masterModifyMerge: function (handler) {
    this.get_events().removeHandler("masterModifyMerge", handler);
  },

  add_standardMerge: function (handler) {
    this.get_events().addHandler("standardMerge", handler);
  },

  remove_standardMerge: function (handler) {
    this.get_events().removeHandler("standardMerge", handler);
  },

  add_standardMerging: function (handler) {
    this.get_events().addHandler("standardMerging", handler);
  },

  remove_standardMerging: function (handler) {
    this.get_events().removeHandler("standardMerging", handler);
  },

  add_standardSizeSort: function (handler) {
    this.get_events().addHandler("standardSizeSort", handler);
  },

  remove_standardSizeSort: function (handler) {
    this.get_events().removeHandler("standardSizeSort", handler);
  },

  add_masterMerge: function (handler) {
    this.get_events().addHandler("masterMerge", handler);
  },

  remove_masterMerge: function (handler) {
    this.get_events().removeHandler("masterMerge", handler);
  },

  add_masterMerging: function (handler) {
    this.get_events().addHandler("masterMerging", handler);
  },

  remove_masterMerging: function (handler) {
    this.get_events().removeHandler("masterMerging", handler);
  }
}
Carpa.Dress.DressBase.registerClass('Carpa.Dress.DressBase', Sys.UI.Controls.Grid);


Carpa.Dress.DressGrid = function (element) {
  Carpa.Dress.DressGrid.initializeBase(this, [element]);
}
Carpa.Dress.DressGrid.prototype = {
  initialize: function () {
    Carpa.Dress.DressGrid.callBaseMethod(this, 'initialize');
    this.add_standardMerging(this._standardMergingHandler);
    this.add_standardMerge(this._standardMergeHandler);
  },

  dispose: function () {
    Carpa.Dress.DressGrid.callBaseMethod(this, 'dispose');
    this.remove_standardMerging(this._standardMergingHandler);
    this.remove_standardMerge(this._standardMergeHandler);
  },

  /*标准视图在合并中引发事件*/
  _standardMergingHandler: function (sender, eventArgs) { },


  /*标准模式下是否合并*/
  _standardMergeHandler: function (sender, eventArgs) {
    eventArgs.add_mergeField("price");
  },

	/*
	 * 重写Grid的方法
	 */
  _createColumns: function () {
    Carpa.Dress.DressGrid.callBaseMethod(this, '_createColumns');
    if (!this._dressMode) {
      return;
    }
    this._bindColumnsEvent();
  },

  /*绑定列相关事件*/
  _bindColumnsEvent: function () {
    if (this._hasPager()) return; //翻页的dressgrid不支持编辑，因为不需要绑定事件

    var columnArray = [];
    //所有列添加变动事件
    var columns = this.get_columns();
    for (var i = 0; i < columns.length; i++) {
      columnArray.push(columns[i].get_dataField());
    }
    var settings = this._gridSetting;
    var item = {
      "raisePtypeChange": settings.PtypeIdField,
      "raiseQtyChange": settings.QtyField,
      "raisePriceChange": settings.PriceField,
      "raiseTotalChange": settings.TotalField,
      "raiseDiscountChange": settings.DiscountField,
      "raiseDiscountTaxPriceChange": settings.DiscountTaxPriceField,
      "raiseDiscountPriceChange": settings.DiscountPriceField,
      "raiseDiscountTotalChange": settings.DiscountTotalField,
      "raiseTaxChange": settings.TaxField,
      "raiseTaxPriceChange": settings.TaxPriceField,
      "raiseTaxTotalChange": settings.TaxTotalField
    };

    for (var i in item) {
      Carpa.Dress.DressGrid.callBaseMethod(this, '_createChangeHandler', [item[i], i]);
      Array.remove(columnArray, i);
    }

    for (var i = 0; i < columnArray.length; i++) {
      Carpa.Dress.DressGrid.callBaseMethod(this, '_createChangeHandler', [columnArray[i], 'commonColumnChange']);
    }
  },

  /*检查参数，并初始化默认值*/
  _checkRowDataDefaultValue: function (rowData) {
    if (rowData[this._gridSetting.QtyField] == null)
      rowData[this._gridSetting.QtyField] = 0;
    if (rowData[this._gridSetting.PriceField] == null)
      rowData[this._gridSetting.PriceField] = 0;
    if (rowData[this._gridSetting.TotalField] == null)
      rowData[this._gridSetting.TotalField] = 0;
    if (rowData[this._gridSetting.DiscountField] == null)
      rowData[this._gridSetting.DiscountField] = 0;
    if (rowData[this._gridSetting.DiscountPriceField] == null)
      rowData[this._gridSetting.DiscountPriceField] = 0;
    if (rowData[this._gridSetting.DiscountTaxPriceField] == null)
      rowData[this._gridSetting.DiscountTaxPriceField] = 0;
    if (rowData[this._gridSetting.DiscountTotalField] == null)
      rowData[this._gridSetting.DiscountTotalField] = 0;
    if (rowData[this._gridSetting.TaxField] == null)
      rowData[this._gridSetting.TaxField] = 0;
    if (rowData[this._gridSetting.TaxPriceField] == null)
      rowData[this._gridSetting.TaxPriceField] = 0;
    if (rowData[this._gridSetting.TaxTotalField] == null)
      rowData[this._gridSetting.TaxTotalField] = 0;
    if (rowData[this._gridSetting.LastTotalField] == null)
      rowData[this._gridSetting.LastTotalField] = 0;
  },

  /*更新尺码对应数量*/
  _updateSizeQty: function (data, rowIndex, sizeQtyColumnName) {
    //处理尺码列变动计算
    Carpa.Dress.DressGrid.callBaseMethod(this, '_doModifyOrAddDetailData', [data, rowIndex]);
    //计算源数据
    var recordList = this.getDressData();
    var mergeFields = this.get_mergeFields();
    var count = recordList.length;
    for (var i = 0; i < count; i++) {
      var tempdata = recordList[i];
      var oldptypeid = tempdata[this._gridSetting.PtypeIdField];
      var oldcolorid = tempdata[this._gridSetting.ColorIdField];
      var oldSizeName = tempdata[this._gridSetting.SizeNameField];
      var oldSizeIndex = this._getSizeIdByName(oldSizeName);
      var oldsizeQtyColumnName = this._getExpandFieldName(oldSizeIndex);
      if (oldptypeid == data[this._gridSetting.PtypeIdField] &&
        oldcolorid == data[this._gridSetting.ColorIdField] &&
        oldsizeQtyColumnName == sizeQtyColumnName) {
        var isAdd = true;
        for (var j = 0, len = mergeFields.length; j < len; j++)
          var fidldName = mergeFields[j];
        if (tempdata[fidldName] != data[fidldName]) {
          isAdd = false;
          break;
        }
      }
      if (isAdd)
        this._updateRowData(tempdata);
    }
    this._updateStandardDataQty(data);
  },

  /*更新标准数据中的数量*/
  _updateStandardDataQty: function (data) {
    //修改数量
    var qtySum = 0;
    for (var name in data) {
      if (name.startsWith(this._qtyExpandName)) {
        var qty = data[name];
        if (qty != null)
          qtySum += qty;
      }
    }
    data[this._gridSetting.QtyField] = qtySum;
    this._updateRowData(data);
  },


  modifySelectedRowData: function (rowData, sender, eventArgs) {
    if (this._displayMode == Sys.UI.Controls.DressDisplayMode.master) {
      var selectIndex = eventArgs.get_rowIndex();
      var items = this.getRowData(selectIndex, true);
      for (var i = 0, length = items.length; i < length; i++) {
        items[i][this._gridSetting.PriceField] = rowData[this._gridSetting.PriceField];
        this._updateRowData(items[i]);
      }
    }

    Carpa.Dress.DressGrid.callBaseMethod(this, 'modifySelectedRowData', [rowData, sender, eventArgs]);
  },

  /*重写修改或添加明细数据*/
  _doModifyOrAddDetailData: function (data, rowIndex) {
    var focusedColumn = this._modifyColumn;
    var columnName = focusedColumn.get_dataField();
    if (this._displayMode == Sys.UI.Controls.DressDisplayMode.standard) {
      if (this._qtyExpandName && columnName.startsWith(this._qtyExpandName)) {
        var oldValue = this._modifyEventArgs.get_oldValue();
        if (data[columnName] == 0 && typeof (oldValue) == 'undefined')
          return;
        this._updateSizeQty(data, rowIndex, columnName);
      }
    }

    Carpa.Dress.DressGrid.callBaseMethod(this, '_doModifyOrAddDetailData', [data, rowIndex]);
  },

  /*计算更新行数数据*/
  _updateRowData: function (data) {
    this._checkRowDataDefaultValue(data);
    var qty = data[this._gridSetting.QtyField];
    var price = data[this._gridSetting.PriceField];
    var total = qty * price;
    this._updatePrice(data, price);
    this._updateTotal(data, total);
  },

  /*计算价税合计，计算税额*/
  _updateTaxTotal: function (rowData, total) {
    if (!this._showTax()) return;

    //计算价税合计
    var taxTotal = Math.roundTo(rowData[this._gridSetting.QtyField] * rowData[this._gridSetting.TaxPriceField] * rowData[this._gridSetting.DiscountField], 2);
    rowData[this._gridSetting.TaxTotalField] = taxTotal;

    var total = Math.roundTo(rowData[this._gridSetting.QtyField] * rowData[this._gridSetting.PriceField], 2);
    rowData[this._gridSetting.TotalField] = total;

    //计算税额
    var lastTotal = Math.roundTo(rowData[this._gridSetting.PriceField] * rowData[this._gridSetting.TaxField], 2);
    rowData[this._gridSetting.LastTotalField] = lastTotal;
  },

  /*计算折后金额和税后金额*/
  _updateTotal: function (rowData, total) {
    var discountTotal = total;

    if (this._showDiscount()) {
      //计算折后金额
      discountTotal = Math.roundTo(total * (rowData[this._gridSetting.DiscountField]), 2);
      rowData[this._gridSetting.DiscountTotalField] = discountTotal;
    }

    this._updateTaxTotal(rowData, total);
  },

  /*计算折后单价和税后单价和折后含税单价*/
  _updatePrice: function (rowData, price) {
    var discountPrice = price;
    if (this._showDiscount()) {
      discountPrice = Math.roundTo(price * rowData[this._gridSetting.DiscountField], 2);
      rowData[this._gridSetting.DiscountPriceField] = discountPrice;
    }

    this._updateTaxPrice(rowData, price);
    this._updateDiscountPriceTaxPrice(rowData, price);
  },

  /*计算税后单价*/
  _updateTaxPrice: function (rowData, price) {
    if (!this._showTax()) return;

    //计算税后单价
    var taxPrice = Math.roundTo(price * (1 + rowData[this._gridSetting.TaxField]), 2);
    rowData[this._gridSetting.TaxPriceField] = taxPrice;
  },

  /*计算折后含税单价*/
  _updateDiscountPriceTaxPrice: function (rowData, price) {
    if (!this._showTax()) return;

    //计算折后含税单价
    var discountTaxPrice = Math.roundTo(rowData[this._gridSetting.TaxPriceField] * rowData[this._gridSetting.DiscountField], 2);
    rowData[this._gridSetting.DiscountTaxPriceField] = discountTaxPrice;
  },

  /*更新行数据，触发计算事件*/
  _updateRowDataForChange: function (sender, eventArgs, columnName) {
    if (this.doComputedColumnChanging(sender, eventArgs))
      return;
    var rowData = this.get_selectedRowData();
    this._updateRowData(rowData);
    if (this._displayMode == Sys.UI.Controls.DressDisplayMode.standard)
      this.doStandardChanging(rowData, columnName);
    this.modifySelectedRowData(rowData, sender, eventArgs);
  },

  /*修改列字段引发事件*/
  raisePtypeChange: function (sender, eventArgs) {
    if (this.doComputedColumnChanging(sender, eventArgs))
      return;
    var qty = eventArgs.get_value();
    if (qty == null) {
      this.clearSelectedRowData();
    }
  },

  /*修改列字段引发事件*/
  raiseQtyChange: function (sender, eventArgs) {
    this._updateRowDataForChange(sender, eventArgs, this._gridSetting.QtyField);
  },

  /*修改列字段引发事件*/
  raisePriceChange: function (sender, eventArgs) {
    this._updateRowDataForChange(sender, eventArgs, this._gridSetting.PriceField);
  },

  /*修改列字段引发事件*/
  raiseTotalChange: function (sender, eventArgs) {
    if (this.doComputedColumnChanging(sender, eventArgs))
      return;
  },

  /*修改列字段引发事件*/
  raiseDiscountChange: function (sender, eventArgs) {
    this._updateRowDataForChange(sender, eventArgs, this._gridSetting.DiscountField);
  },

  /*修改列字段引发事件*/
  raiseDiscountTaxPriceChange: function (sender, eventArgs) {
    if (this.doComputedColumnChanging(sender, eventArgs))
      return;
  },

  /*修改列字段引发事件*/
  raiseDiscountPriceChange: function (sender, eventArgs) {
    if (this.doComputedColumnChanging(sender, eventArgs))
      return;
  },

  /*修改列字段引发事件*/
  raiseDiscountTotalChange: function (sender, eventArgs) {
    if (this.doComputedColumnChanging(sender, eventArgs))
      return;
    var rowData = this.get_selectedRowData();
  },

  /*修改列字段引发事件*/
  raiseTaxChange: function (sender, eventArgs) {
    this._updateRowDataForChange(sender, eventArgs, this._gridSetting.TaxField);
  },

  /*修改列字段引发事件*/
  raiseTaxPriceChange: function (sender, eventArgs) {
    if (this.doComputedColumnChanging(sender, eventArgs))
      return;
    var rowData = this.get_selectedRowData();
  },

  /*修改列字段引发事件*/
  raiseTaxTotalChange: function (sender, eventArgs) {
    if (this.doComputedColumnChanging(sender, eventArgs))
      return;
    var rowData = this.get_selectedRowData();
  },

  //计算列变化事件
  doComputedColumnChanging: function (sender, eventArgs) {
    var handler = this.get_events().getHandler("computedColumnChange");
    var isEdit = false;
    if (handler) {
      isEdit = handler(sender, eventArgs);
    }
    return isEdit;
  },

  /*添加列数据变化，引发计算列事件*/
  add_computedColumnChange: function (handler) {
    this.get_events().addHandler("computedColumnChange", handler);
  },

  /*移除列数据变化，引发计算列事件*/
  remove_computedColumnChange: function (handler) {
    this.get_events().removeHandler("computedColumnChange", handler);
  }
}
Carpa.Dress.DressGrid.registerClass('Carpa.Dress.DressGrid', Carpa.Dress.DressBase);